    .data
    # Dichiariamo la variabile globale "risultato"
risultato:  
    .word 1

    .text
    .globl fattoriale_dispari
moltiplica_condizionale:
    # Se il primo parametro è 0, esci dalla funzione immediatamente
    beq $zero, $a0, fine

    # Carica il suo valore
    lw $t1, risultato

    # Moltiplicalo per il secondo parametro
    mul $t2, $t1, $a1

    # Aggiorna il valore della variabile globale "risultato"
    sw $t2, risultato
fine:
    # Esci dalla funzione
    j $ra
    
fattoriale_dispari:
    # Questa volta decidiamo di usare il frame pointer e di usare per i calcoli
    # intermedia il registr $s0, che è callee-saved
    # Quindi sullo stack salveremo: $fp, $ra, $s0
    addi $sp, -12

    # Offset a cui salvare il frame pointer, rispetto a $sp
    .eqv FP, 8
    # Salva il frame pointer
    sw $fp, FP($sp)
    # Imposta il nuovo frame pointer. Il frame pointer punta sempre al frame
    # pointer precedente
    addiu $fp, $sp, FP

    # Offset dei valori salvati sullo stack, in relazione al frame pointer
    .eqv RA, -4
    .eqv S0, -8
    # Salve $ra e $s0
    sw $ra, RA($fp)
    sw $s0, S0($fp)
    # Copia il primo argomento in $s0
    move $s0, $a0

loophead:
    # Controlla se l'argomento "a" è minore o uguale a zero
    blez $s0, loopend

    # Chiama "moltiplica_condizionale", non è necessario salvare $s0 qui, se
    # la funzione chiamata lo usasse, lo salverebbe e ripristinerebbe
    move $a1, $s0
    and $a0, $s0, 1
    jal moltiplica_condizionale

    # Decrementa "a"
    addi $s0, -1

    # Fai un'altra iterazione
    j loophead
loopend:
    # Carica il valore della variabile globale "risultato" e restituiscilo
    lw $v0, risultato

    # Ripristina $s0, $ra e $fp
    lw $s0, S0($fp)
    lw $ra, RA($fp)
    lw $fp, FP($sp)
    # Ripristina lo stack
    addiu $sp, $sp, 12
    j $ra
